moSetGetPdaTypeLightXML = {};

function moSetGetPdaTypeLightXML:loadConfig(Xml, xmlType)
	local xmlNameTag = xmlType;
	if Xml ~= nil then
		if xmlType == "pdaTypeLightXML" then
			local groupNameTag = (xmlNameTag.. ".global(%d)"):format(0);
			if getXMLBool(Xml, groupNameTag.."#isOn") ~= nil then
				moGeneralSettings.pdaType.light = getXMLBool(Xml, groupNameTag.. "#isOn");
			end;				
			local errorLoad = false;
			local pda = 1;
			while true do
				groupNameTag = (xmlNameTag.. ".pda".. tostring(pda).. "(%d)"):format(0);
				local appGroupNameTag = (groupNameTag.. ".app(%d)"):format(0);
				if pda > 1 and moSetGetOverlaysLight.default.pda[pda-1] == nil then errorLoad = true;break;end;
				if errorLoad or groupNameTag == nil or appGroupNameTag == nil or getXMLBool(Xml, groupNameTag.."#autoWidth") == nil or pda > 5 then break;else
					moSetGetOverlaysLight:generatePdaOverXml(pda);
					if pda == 1 then
						if getXMLBool(Xml, groupNameTag.."#autoWidth") ~= nil and moSetGetOverlaysLight.default.pda[pda].autoWidth ~= nil then
							moSetGetOverlaysLight.default.pda[pda].autoWidth = getXMLBool(Xml, groupNameTag.."#autoWidth");
						end;						
					else
						moSetGetOverlaysLight.default.pda[pda].autoWidth = false;
						if getXMLBool(Xml, groupNameTag.."#view") ~= nil then
							moSetGetOverlaysLight.default.pda[pda].view[1] = getXMLBool(Xml, groupNameTag.."#view");
						end;
					end;
					if getXMLInt(Xml, groupNameTag.."#minViewApps") ~= nil then
						moSetGetOverlaysLight.default.pda[pda].minViewApps = getXMLInt(Xml, groupNameTag.."#minViewApps");
						if moSetGetOverlaysLight.default.pda[pda].minViewApps < moSetGetOverlaysLight.default.limitMinViewApps then moSetGetOverlaysLight.default.pda[pda].minViewApps = moSetGetOverlaysLight.default.limitMinViewApps;end;
					end;
					if getXMLInt(Xml, groupNameTag.."#maxViewApps") ~= nil then
						moSetGetOverlaysLight.default.pda[pda].maxViewApps = getXMLInt(Xml, groupNameTag.."#maxViewApps");
						if moSetGetOverlaysLight.default.pda[pda].maxViewApps > moSetGetOverlaysLight.default.limitMaxViewApps then moSetGetOverlaysLight.default.pda[pda].maxViewApps = moSetGetOverlaysLight.default.limitMaxViewApps;end;
					end;					
					moSetGetPdaTypeLightXML:loadPda(pda, Xml, groupNameTag);
					pda = pda+1;					
				end;
			end;
			if errorLoad then
				print("!!!! WARNING !!!!".. tostring(MultiOverlayV4.metadata.title).. " load file error pdaTypeLightSettings.xml");
			end;
		end;
	end;	
end;

function moSetGetPdaTypeLightXML:loadPda(pda, Xml, groupNameTag)	
	local maxApps = #moSetGetOverlaysLight.default.pdaDefault.app;	
	local app = 1;
	local apps = 0;
	local defaultAppOrder = g_currentMission.hl.getTableCopy(moSetGetOverlaysLight.default.pdaDefault.appOrder);	
	while true do
		local appGroupNameTag = (groupNameTag.. ".app(%d)"):format(apps);
		if appGroupNameTag == nil or getXMLInt(Xml, appGroupNameTag.. "#name") == nil or apps > maxApps then break;end;
		local iconName = getXMLString(Xml, appGroupNameTag.. "#name");
		local defaultAppPos = moSetGetOverlaysLight.default.pdaDefault.appOrder[iconName];
		defaultAppOrder[iconName] = nil;
		moSetGetOverlaysLight.default.pda[pda].app[app] = moSetGetOverlaysLight.default.pdaDefault.app[defaultAppPos];
		local appTable = moSetGetOverlaysLight.default.pda[pda].app[app];
		if appTable ~= nil and appTable.view ~= nil then
			if getXMLBool(Xml, appGroupNameTag.."#view") ~= nil then
				appTable.view = getXMLBool(Xml, appGroupNameTag.."#view");
			end;
			if appTable.autoClose ~= nil and getXMLBool(Xml, appGroupNameTag.."#autoClose") ~= nil then
				appTable.autoClose = getXMLBool(Xml, appGroupNameTag.."#autoClose");
			end;
			if appTable.infoBar ~= nil and appTable.infoBar.view ~= nil and getXMLBool(Xml, appGroupNameTag.."#viewInfoBar") ~= nil then
				appTable.infoBar.view = getXMLBool(Xml, appGroupNameTag.."#viewInfoBar");
			end;
			if appTable.textTicker ~= nil and appTable.textTicker.view ~= nil and getXMLBool(Xml, appGroupNameTag.."#viewTextTicker") ~= nil then
				appTable.textTicker.view = getXMLBool(Xml, appGroupNameTag.."#viewTextTicker");
			end;		
			app = app+1;
		end;
		apps = apps+1;				
	end;
	function searchMissingApps()		
		for _,defaultAppPos in pairs (defaultAppOrder) do
			table.insert(moSetGetOverlaysLight.default.pda[pda].app, defaultAppPos, moSetGetOverlaysLight.default.pdaDefault.app[defaultAppPos] );
			moSetGetOverlaysLight.default.pda[pda].app[defaultAppPos].newApp = true;			
		end;
	end;
	searchMissingApps();
	moSetGetOverlaysLight:generatePda(pda, true);
end;

function moSetGetPdaTypeLightXML:saveConfig(xmlType, firstStart)
	moGeneralSettings.pdaType.lightFirstStart = firstStart or false;
	local file = MultiOverlayV4.settingsDir.. "pdaTypeLightSettings.xml";
	local Xml = createXMLFile("MultiOverlayV4_XML", file, xmlType);
	local xmlNameTag = xmlType;
	if Xml ~= nil then
		if xmlType == "pdaTypeLightXML" then
			local groupNameTag = (xmlNameTag.. ".info(%d)"):format(0);
			setXMLString(Xml, groupNameTag.."#WARNING", "NOT EDIT THIS XML OR MOH CAN CRASH");
			groupNameTag = (xmlNameTag.. ".global(%d)"):format(0);
			setXMLBool(Xml, groupNameTag.. "#isOn", moGeneralSettings.pdaType.light);
			if #moSetGetOverlaysLight.default.pda > 0 then
				for pda=1, #moSetGetOverlaysLight.default.pda do
					local pdaTable = moSetGetOverlaysLight.default.pda[pda];					
					groupNameTag = (xmlNameTag.. ".pda".. tostring(pda).. "(%d)"):format(0);
					setXMLBool(Xml, groupNameTag.."#autoWidth",pdaTable.autoWidth);
					setXMLBool(Xml, groupNameTag.."#view",pdaTable.view[1]);
					setXMLInt(Xml, groupNameTag.."#minViewApps",pdaTable.minViewApps);
					setXMLInt(Xml, groupNameTag.."#maxViewApps",pdaTable.maxViewApps);					
					local apps = 0;
					for pos, app in pairs (pdaTable.app) do					
						local appGroupNameTag = (groupNameTag.. ".app(%d)"):format(apps);
						setXMLString(Xml, appGroupNameTag.."#name",app.iconName);
						--setXMLBool(Xml, appGroupNameTag.."#intern",app.intern);
						setXMLBool(Xml, appGroupNameTag.."#view",app.view);
						if app.autoClose ~= nil then
							setXMLBool(Xml, appGroupNameTag.."#autoClose",app.autoClose);
						end;
						if app.infoBar ~= nil and app.infoBar.view ~= nil then
							setXMLBool(Xml, appGroupNameTag.."#viewInfoBar",app.infoBar.view);
						end;
						if app.textTicker ~= nil and app.textTicker.view ~= nil then
							setXMLBool(Xml, appGroupNameTag.."#viewTextTicker",app.textTicker.view);
						end;
						apps = apps+1;
					end;									
				end;			
			end;			
		end;
		saveXMLFile(Xml);		
	else
		print("!!!! WARNING !!!!".. tostring(MultiOverlayV4.metadata.title).. " save file error "..file);	
	end;	
end;
