moDrawLightSettings = {};

function moDrawLightSettings:setOpen()
	local pda = moSetGetOverlaysLight.default.setting.selectPda;	
	if pda == 0 or moSetGetOverlaysLight.default.pda[pda] == nil then moSetGetOverlaysLight.default.setting.on = false;return;end;
	moGeneralSettings.clickAreas.lightSetting["lightSettingPda"] = {};
	moGeneralSettings.clickAreas.lightSettingPda["lightSettingPda"] = {};
	local disableClickArea = g_currentMission.hl.dragDrop.on or not g_currentMission.hl.isMouseCursor;
	if disableClickArea or g_currentMission.hlGui.menue.isOpen then moSetGetOverlaysLight.default.setting.on = false;return;end;
	local pdaTable = moSetGetOverlaysLight.default.pda[pda];
	if pdaTable.app == nil or #pdaTable.app <= 0 then 
		moSetGetOverlaysLight.default.setting.on = false;
		g_currentMission.hl.addTextDisplay( {txt="!! App missing !!\nLight Pda have incorrect values", txtBold=true, duration=4, warning=true} );
		return;
	end;
	if moSetGetOverlaysLight.default.setting.selectApp > #pdaTable.app or moSetGetOverlaysLight.default.setting.selectApp < 0 then moSetGetOverlaysLight.default.setting.selectApp = 0;end;
	local isMasterPda = pda == 1;
	local edgeWidth = 2;
	local edgeHeight = 3;
	local maxAppWidth = moSetGetOverlaysLight.default.setting.maxAppWidth;
	local width = moSetGetOverlaysLight.default.appWidth*(maxAppWidth+edgeWidth);
	local height = moSetGetOverlaysLight.default.appHeight*(math.ceil(#pdaTable.app/maxAppWidth)+edgeHeight);	
	
	--background--
	local overlay = moSetGetOverlaysLight.default.setting.icon.background;
	g_currentMission.hl.setOverlay(overlay, 0.5-(width/2), 0.5, width, height);
	overlay:render();
	if not disableClickArea then 
		local areaWidth = overlay.x+overlay.width;
		if moSetGetOverlaysLight.default.setting.selectApp ~= 0 then areaWidth = areaWidth+(width/4)+0.002;end;
		moDrawLightSettings:clickAreas(true, {overlay.x, areaWidth, overlay.y, overlay.y+overlay.height, whatClick="lightSettingPda"});
	end;
	--background--	
	--buttonClose--
	local tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonClose;
	g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-(tempOverlay.width), overlay.y+overlay.height-(tempOverlay.height));
	tempOverlay:render();
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="buttonClose_"});end;
	--buttonClose--
	--buttonSave--
	local color = "green";
	if not moGeneralSettings.isSave then color = "yellow";end;
	tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonSave;
	g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-(tempOverlay.width*2), overlay.y+overlay.height-(tempOverlay.height));
	g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
	tempOverlay:render();
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="buttonSave_"});end;
	--buttonSave--
	--buttonDelete--
	if not isMasterPda then
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonDelete;
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width-(tempOverlay.width*3), overlay.y+overlay.height-(tempOverlay.height));
		tempOverlay:render();
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="buttonDelete_"});end;
	end;
	--buttonDelete--
	--info headline--
	color = "darkYellow";
	setTextBold(true);
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	local txt = "Click AppIcons/Text Left/Right/Middle for Action (if available)"
	local optiSize = g_currentMission.hl.optiWidthSize(overlay.width-tempOverlay.width, txt, 0.015);
	renderText(overlay.x, overlay.y+overlay.height, optiSize, txt);
	--info headline--
	
	----------------------------
	color = moSetGetOverlaysLight.default.iconColor.inactive;
	optiSize = moSetGetOverlaysLight.default.optiHeightSize;
	local posX = overlay.x-(moSetGetOverlaysLight.default.appWidth/2);
	local firstPosX = overlay.x-(moSetGetOverlaysLight.default.appWidth/2);
	local posY = overlay.y+overlay.height-(moSetGetOverlaysLight.default.appHeight*(edgeHeight/1.5));
	local iconColor = moSetGetOverlaysLight.default.iconColor.default;
	local txtSeperatorWidth = getTextWidth(optiSize, utf8Substr(" | ", 0));	
	function setTxtSeparator(txtPosX, txtPosY)
		color = moSetGetOverlaysLight.default.iconColor.inactive
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, "|");
	end;	
	--autoWidth--
	color = moSetGetOverlaysLight.default.iconColor.inactive;
	txt = "AutoWidth OFF";
	local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
	if isMasterPda then
		if pdaTable.autoWidth then color = moSetGetOverlaysLight.default.iconColor.enabled;txt = "AutoWidth ON";else color = moSetGetOverlaysLight.default.iconColor.disabled;end;	
	end;
	local txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));	
	local txtPosX = overlay.x+moSetGetOverlaysLight.default.appWidth;
	local txtPosY = overlay.y+(moSetGetOverlaysLight.default.appHeight/4);		
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="autoWidthOnOff_"});end;
	txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
	--autoWidth--
	
	setTxtSeparator(txtPosX, txtPosY);
	
	--min/max view apps--
	color = moSetGetOverlaysLight.default.iconColor.enabled;
	txt = "Min. view Apps ".. tostring(pdaTable.minViewApps);
	if pdaTable.autoWidth then color = moSetGetOverlaysLight.default.iconColor.inactive;txt = "Min. view Apps ".. tostring(moSetGetOverlaysLight.default.limitMinViewApps);end;
	txtPosX = txtPosX+txtSeperatorWidth;	
	txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));	
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="minViewApps_"});end;
	txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
	--min/max view apps--
	
	setTxtSeparator(txtPosX, txtPosY);
	
	--key settings--
	color = moSetGetOverlaysLight.default.iconColor.inactive;
	txt = "Key Control";
	local txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
	txtPosX = txtPosX+txtSeperatorWidth;	
	txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	if not disableClickArea then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, txtPosY, txtPosY+txtHeight, whatClick="lightSettingPda", whereClick="keyControl_"});end;
	txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
	--key settings--
	
	----line 2----
	--apps total--
	color = moSetGetOverlaysLight.default.iconColor.default;
	txt = "Apps: 99";
	txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));	
	local txtHeight = getTextHeight(optiSize, utf8Substr(txt, 0));	
	txt = "Apps: ".. tostring(#pdaTable.app);
	txtPosX = overlay.x+moSetGetOverlaysLight.default.appWidth;
	txtPosY = txtPosY+(txtHeight*1.3);
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
	--Apps total--
	
	setTxtSeparator(txtPosX, txtPosY);
	
	--view apps total info--	
	color = moSetGetOverlaysLight.default.iconColor.default;
	txt = "View Apps: ".. tostring(#moSetGetLight:getPdaViewApps(pda));		
	txtPosX = txtPosX+txtSeperatorWidth;	
	setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
	renderText(txtPosX, txtPosY, optiSize, txt);
	txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
	--view Apps total info--
	----line 2----
	
	if moSetGetOverlaysLight.default.setting.selectApp ~= 0 then
		--background App--
		local tempOverlay = moSetGetOverlaysLight.default.setting.icon.backgroundApp;
		g_currentMission.hl.setOverlay(tempOverlay, overlay.x+overlay.width+0.002, 0.5, width/4, height);
		tempOverlay:render();	
		--background App--		
		local selectApp = pdaTable.app[moSetGetOverlaysLight.default.setting.selectApp];
		local tempPosX = tempOverlay.x+(moSetGetOverlaysLight.default.appWidth/2);
		local tempPosY = overlay.y+overlay.height-(moSetGetOverlaysLight.default.appHeight);
		local firstTempPosX = tempOverlay.x+(moSetGetOverlaysLight.default.appWidth/2);
		---icon + typ--
		local appOverlay = pdaTable.appIcon[moSetGetOverlaysLight.default.setting.selectApp];
		local oldAppPosY = appOverlay.y;
		g_currentMission.hl.setOverlay(appOverlay, tempPosX, tempPosY-0.002);
		color = moSetGetOverlaysLight.default.iconColor.open;
		g_currentMission.hl.setBackgroundColor(appOverlay, g_currentMission.hl.getColor(color, true));
		appOverlay:render();
		txtPosX = appOverlay.x+appOverlay.width+0.002;		
		txtPosY = appOverlay.y+(appOverlay.height/2)+0.001;
		local otherTxtPosY = appOverlay.y+0.001;
		g_currentMission.hl.setOverlay(appOverlay, nil, oldAppPosY);
		txt = "Typ: ".. tostring(selectApp.typ:upper());
		local otherTxt = "Open/Close";
		if selectApp.typ == "cmd" then otherTxt = "Activate";end;
		setTextColor(unpack(g_currentMission.hl.getColor("white", true)));
		renderText(txtPosX, txtPosY, optiSize-0.002, txt);		
		renderText(txtPosX, otherTxtPosY, optiSize-0.002, otherTxt);
		---icon + typ--
		tempPosY = overlay.y+overlay.height-(moSetGetOverlaysLight.default.appHeight*1.8);
		--app position--		
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonLeftRight;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, tempPosY);
		color = moSetGetOverlaysLight.default.iconColor.open;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "Pos ".. tostring(moSetGetOverlaysLight.default.setting.selectApp);
		txtWidth = getTextWidth(optiSize, utf8Substr("Pos 99", 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appLeftRight_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--app position--
				
		tempPosY = tempOverlay.y-tempOverlay.height-(txtHeight/2);	
		
		--view app--
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonView;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, tempPosY);
		if selectApp.view then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "View this App";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		color = moSetGetOverlaysLight.default.iconColor.open;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appView_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--view app--
		
		tempPosY = tempOverlay.y-tempOverlay.height-(txtHeight/2);
		
		--autoClose--			
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonAutoClose;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, tempPosY);
		color = moSetGetOverlaysLight.default.iconColor.inactive;
		if selectApp.typ ~= "cmd" then
			if selectApp.autoClose then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "AutoClose";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		if color == moSetGetOverlaysLight.default.iconColor.enabled or color == moSetGetOverlaysLight.default.iconColor.disabled then color = moSetGetOverlaysLight.default.iconColor.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appAutoClose_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--if selectApp.typ == "cmd" then
		--	local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, overlay.y, tempOverlay.y+tempOverlay.height});
		--	if isInArea and #g_currentMission.hl.textDisplay == 0 then g_currentMission.hl.addTextDisplay( {txt="For Cmd AppIcons not available", txtBold=true, duration=3, warning=true} );end;
		--end;		
		--autoClose--
		
		tempPosY = tempOverlay.y-tempOverlay.height-(txtHeight/2);
		
		--infoBar--		
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonInfoBar;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, tempPosY);
		color = moSetGetOverlaysLight.default.iconColor.inactive;
		if selectApp.typ == "slot" and selectApp.infoBar ~= nil and selectApp.infoBar.view ~= nil then
			if selectApp.infoBar.view then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "InfoBar";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		if color == moSetGetOverlaysLight.default.iconColor.enabled or color == moSetGetOverlaysLight.default.iconColor.disabled then color = moSetGetOverlaysLight.default.iconColor.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appInfoBar_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--if selectApp.infoBar == nil or selectApp.infoBar.view == nil then
		--	local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, overlay.y, tempOverlay.y+tempOverlay.height});
		--	if isInArea and #g_currentMission.hl.textDisplay == 0 then g_currentMission.hl.addTextDisplay( {txt="Not Installed for this AppIcon", txtBold=true, duration=3, warning=true} );end;
		--end;		
		--infoBar--
		
		tempPosY = tempOverlay.y-tempOverlay.height-(txtHeight/2);
		
		--textTicker--					
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonOnOff;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, tempPosY);
		color = moSetGetOverlaysLight.default.iconColor.inactive;
		if moGeneralSettings.textTicker.isOn then
			if selectApp.textTicker ~= nil and selectApp.textTicker.view ~= nil then
				if selectApp.textTicker.view then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
			end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "Text Ticker";	
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		if color == moSetGetOverlaysLight.default.iconColor.enabled or color == moSetGetOverlaysLight.default.iconColor.disabled then color = moSetGetOverlaysLight.default.iconColor.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appTextTicker_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--textTicker--
	end;
	
	
	if old and moSetGetOverlaysLight.default.setting.selectApp ~= 0 then
		local selectApp = pdaTable.app[moSetGetOverlaysLight.default.setting.selectApp];
		local tempPosX = overlay.x+moSetGetOverlaysLight.default.appWidth;
		--view app--
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonView;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+moSetGetOverlaysLight.default.appHeight);
		if selectApp.view then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "View";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;
		txtPosY = tempOverlay.y+(tempOverlay.height/2)-(txtHeight/2);
		color = moSetGetOverlaysLight.default.iconColor.open;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appView_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
		--view app--
		setTxtSeparator(txtPosX, txtPosY);	
		--app position--
		tempPosX = txtPosX+txtSeperatorWidth+0.001;
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonLeftRight;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+moSetGetOverlaysLight.default.appHeight);
		color = moSetGetOverlaysLight.default.iconColor.open;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "Pos ".. tostring(moSetGetOverlaysLight.default.setting.selectApp);
		txtWidth = getTextWidth(optiSize, utf8Substr("Pos 99", 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appLeftRight_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
		--app position--
		setTxtSeparator(txtPosX, txtPosY);	
		--autoClose--
		tempPosX = txtPosX+txtSeperatorWidth+0.001;		
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonAutoClose;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+moSetGetOverlaysLight.default.appHeight);
		color = moSetGetOverlaysLight.default.iconColor.inactive;
		if selectApp.typ ~= "cmd" then
			if selectApp.autoClose then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "AutoClose";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		if color == moSetGetOverlaysLight.default.iconColor.enabled or color == moSetGetOverlaysLight.default.iconColor.disabled then color = moSetGetOverlaysLight.default.iconColor.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appAutoClose_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--if selectApp.typ == "cmd" then
		--	local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, overlay.y, tempOverlay.y+tempOverlay.height});
		--	if isInArea and #g_currentMission.hl.textDisplay == 0 then g_currentMission.hl.addTextDisplay( {txt="For Cmd AppIcons not available", txtBold=true, duration=3, warning=true} );end;
		--end;
		txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
		--autoClose--
		setTxtSeparator(txtPosX, txtPosY);
		--infoBar--
		tempPosX = txtPosX+txtSeperatorWidth+0.001;	
		tempOverlay = moSetGetOverlaysLight.default.setting.icon.buttonInfoBar;
		g_currentMission.hl.setOverlay(tempOverlay, tempPosX, overlay.y+moSetGetOverlaysLight.default.appHeight);
		color = moSetGetOverlaysLight.default.iconColor.inactive;
		if selectApp.typ == "slot" and selectApp.infoBar ~= nil and selectApp.infoBar.view ~= nil then
			if selectApp.infoBar.view then color = moSetGetOverlaysLight.default.iconColor.enabled;else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
		end;
		g_currentMission.hl.setBackgroundColor(tempOverlay, g_currentMission.hl.getColor(color, true));
		tempOverlay:render();
		txt = "InfoBar";
		txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
		txtPosX = tempOverlay.x+tempOverlay.width+0.001;		
		if color == moSetGetOverlaysLight.default.iconColor.enabled or color == moSetGetOverlaysLight.default.iconColor.disabled then color = moSetGetOverlaysLight.default.iconColor.open;end;
		setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
		renderText(txtPosX, txtPosY, optiSize, txt);
		if not disableClickArea then moDrawLightSettings:clickAreas(false, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appInfoBar_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
		--if selectApp.infoBar == nil or selectApp.infoBar.view == nil then
		--	local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {tempOverlay.x, tempOverlay.x+tempOverlay.width+txtWidth, overlay.y, tempOverlay.y+tempOverlay.height});
		--	if isInArea and #g_currentMission.hl.textDisplay == 0 then g_currentMission.hl.addTextDisplay( {txt="Not Installed for this AppIcon", txtBold=true, duration=3, warning=true} );end;
		--end;
		txtPosX = txtPosX+txtWidth+txtSeperatorWidth;
		--infoBar--
		--textTicker--
		if selectApp.typ == "slot" and selectApp.textTicker ~= nil and selectApp.textTicker.view ~= nil then
			setTxtSeparator(txtPosX, txtPosY);
			--textTicker--
			txtPosX = txtPosX+txtSeperatorWidth+0.001;
			color = moSetGetOverlaysLight.default.iconColor.inactive;
			txt = "TextTicker Off";						
			if moGeneralSettings.textTicker.isOn then
				if selectApp.textTicker.view then color = moSetGetOverlaysLight.default.iconColor.enabled;txt = "TextTicker On";else color = moSetGetOverlaysLight.default.iconColor.disabled;end;
			end;			
			txtWidth = getTextWidth(optiSize, utf8Substr(txt, 0));
			setTextColor(unpack(g_currentMission.hl.getColor(color, true)));
			renderText(txtPosX, txtPosY, optiSize, txt);
			if not disableClickArea then moDrawLightSettings:clickAreas(false, {txtPosX, txtPosX+txtWidth, tempOverlay.y, tempOverlay.y+tempOverlay.height, whatClick="lightSettingPda", whereClick="appTextTicker_", app=moSetGetOverlaysLight.default.setting.selectApp});end;
			--textTicker--
		end;
		--textTicker--
	end;
	--appIcons
	setTextBold(false);		
	setTextColor(1, 1, 1, 1);
	local appPos = 1;
	for app=1, #pdaTable.app do
		overlay = pdaTable.appIcon[app];
		if overlay ~= nil then
			local oldPosY = overlay.y
			g_currentMission.hl.setOverlay(overlay, posX+(moSetGetOverlaysLight.default.appWidth*(appPos)), posY);			
			if pdaTable.app[app].view then iconColor = moSetGetOverlaysLight.default.iconColor.default;else iconColor = moSetGetOverlaysLight.default.iconColor.inactive;end;
			local isInArea = moDraw.light:getIconSelectColor(disableClickArea, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height});
			if app == moSetGetOverlaysLight.default.setting.selectApp then iconColor = moSetGetOverlaysLight.default.iconColor.open;end;
			if isInArea then 
				tempOverlay = moSetGetOverlaysLight.default.setting.icon.appSelect;
				g_currentMission.hl.setOverlay(tempOverlay, overlay.x, overlay.y-0.005);
				tempOverlay:render();
				--iconColor = moSetGetOverlaysLight.default.iconColor.select;
			end;
			g_currentMission.hl.setBackgroundColor(overlay, g_currentMission.hl.getColor(iconColor, true));
			overlay:render();
			if not disableClickArea then moDrawLightSettings:clickAreas(false, {overlay.x, overlay.x+overlay.width, overlay.y, overlay.y+overlay.height, whatClick="lightSettingPda", whereClick="appIcon_", app=app});end;
			local txtNew = "NEW";
			txt = tostring(pdaTable.app[app].typ:upper());
			if pdaTable.app[app].newApp ~= nil and g_currentMission.hl.runsTimer("2sec", true) then txt = txtNew;iconColor="orange";setTextBold(true);end;
			setTextColor(unpack(g_currentMission.hl.getColor(iconColor, true)));
			txtWidth = getTextWidth(optiSize-0.004, utf8Substr(txt, 0));			
			renderText(overlay.x+(overlay.width/2)-(txtWidth/2), overlay.y+overlay.height+0.001, optiSize-0.004, txt);			
			g_currentMission.hl.setOverlay(overlay, nil, oldPosY);
			setTextBold(false);
			setTextColor(1, 1, 1, 1);
			
			
			appPos = appPos+1;
			if appPos > maxAppWidth then appPos = 1;posX = firstPosX;posY = posY-(moSetGetOverlaysLight.default.appHeight*1.5);end;
		end;
	end;
	--appIcons--
end;

function moDrawLightSettings:clickAreas(masterArea, args)	
	if masterArea ~= nil and masterArea then
		moGeneralSettings.clickAreas.lightSetting[args.whatClick] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1
			whichArea=args.whatClick;
			pda	= moSetGetOverlaysLight.default.setting.selectPda;		
		};
	else	
		if moGeneralSettings.clickAreas.lightSettingPda[args.whatClick] == nil then moGeneralSettings.clickAreas.lightSettingPda[args.whatClick] = {};end;
		moGeneralSettings.clickAreas.lightSettingPda[args.whatClick][#moGeneralSettings.clickAreas.lightSettingPda[args.whatClick]+1] = {
			args[1]; --posX
			args[2]; --posX1
			args[3]; --posY
			args[4]; --posY1			
			mouseClick = "";
			whatClick = args.whatClick;			
			whereClick = args.whereClick;			
			app = args.app;
			pda = moSetGetOverlaysLight.default.setting.selectPda;
		};		
	end;
end;