moLanguageXml = {};

function moLanguageXml:loadTable()	
	moLanguage = {};
	MultiOverlayV4.language = "_".. string.lower(g_languageShort);
	MultiOverlayV4.languageAccepts = {"_en"; "_de"; "_nl"; "_es"; "_it"; "_fr"; "_hu"; "_pl"; "_ru"; "_ro"};	
	moLanguageXml:loadLanguages();
end;


--tostring(moLanguageXml:getTxt("setfrozeninfo", nil, nil, nil, true))
function moLanguageXml:getTxt(text, maxString, oldNameReturn, toLong, intern)	
	local txt = "L Error";
	local toLongTxt = "";
	local languageXML = moLanguage;
	if intern then languageXML = moLanguageIntern;end;
	local languageTable = MultiOverlayV4.language;
	if languageXML ~= nil and languageXML[text] ~= nil then
		if languageXML[text][languageTable] == nil then			
			for a=1, #MultiOverlayV4.languageAccepts do
				if languageXML[text][MultiOverlayV4.languageAccepts[a]] ~= nil then txt = languageXML[text][MultiOverlayV4.languageAccepts[a]];break;end; --languageTable = MultiOverlayV4.languageAccepts[a];break;end;
			end;
		else
			txt = languageXML[text][languageTable];
		end;		
		if maxString ~= nil then
			local cutName = txt;			
			if string.len(cutName) > tonumber(maxString) then
				if toLong ~= nil and toLong then maxString = maxString-2;toLongTxt = ".."end;
				cutName = string.sub(txt, 0, tonumber(maxString)).. toString(toLongTxt);
			end;
			txt = cutName;
		end;		
		if txt == nil or string.len(txt) == 0 then txt = "L Missing";end;
	end;
	if oldNameReturn ~= nil then
		if txt == "L Missing" or txt == "L Error" then txt = oldNameReturn;end;
	end;
	return txt;
end;

function moLanguageXml:loadLanguages()		
	moDeleteOldLanguage = {};
	moLanguageDefault = {								
		year = 					{_de="Jahr",					_en="Year",						_ru="Год",       				_nl="Jaar",				_fr="Année",		_pl="Rok",		_it="Anno",		_es="Año",		_hu="Év",		_ro="An"};
		years = 				{_de="Jahre",					_en="Years",					_ru="Лет",       				_nl="Jaren",			_fr="Années",		_pl="Lata",		_it="Anni",		_es="Años",		_hu="Évek",		_ro="Ani"};
		on = 					{_de="An",						_en="On",						_ru="Вкл",						_nl="Aan"};													
		off = 					{_de="Aus",					 	_en="Off",						_ru="Выкл",						_nl="Uit"};
		yes = 					{_de="Ja", 						_en="Yes",						_ru="Да",						_nl="Yes"};
		no = 					{_de="Nein", 					_en="No",						_ru="Нет",						_nl="No"};
		per = 					{_de="pro", 					_en="per",						_ru="за",						_nl="per"};
		siloextensions = 		{_de="Siloerweiterung", 		_en="Siloextension",			_ru="Расш. бункера"};
		money = 				{_de="Geld", 					_en="Money",					_ru="Деньги"};
		moneysymbol = 			{_de="€", 						_en="€"};
		moneycurrency = 		{_de="Euro", 					_en="Euro",						_ru="Евро"};
		day1 = 					{_de="(Mo)", 					_en="(Mon)",					_ru="(Пн)"};
		day2 = 					{_de="(Di)", 					_en="(Tue)",					_ru="(Вт)"};
		day3 = 					{_de="(Mi)", 					_en="(Wed)",					_ru="(Ср)"};
		day4 = 					{_de="(Do)",	 				_en="(Thu)",					_ru="(Чт)"};
		day5 = 					{_de="(Fr)", 					_en="(Fri)",					_ru="(Пт)"};
		day6 = 					{_de="(Sa)", 					_en="(Sat)",					_ru="(Сб)"};
		day7 = 					{_de="(So)", 					_en="(Sun)",					_ru="(Вс)"};	
		day = 					{_de="Tag", 					_en="Day",						_ru="День"};
		days = 					{_de="Tag(e)", 					_en="Day(s)",					_ru="День(дней)"};
		playdays = 				{_de="Spieltage", 				_en="PlayDays";					_ru="Игровые дни",				_nl="Speldagen"};
		productivity = 			{_de="Produktivität", 			_en="Productivity",				_ru="Произведено"};
		usage = 				{_de="Auslastung",				_en="Usage",					_ru="Использовано"};
		capacity = 				{_de="Kapazität", 				_en="Capacity",					_ru="Вместимость"};
		field = 				{_de="Feld", 					_en="Field",					_ru="Поле"};
		fields = 				{_de="Felder",					_en="Fields",					_ru="Поля"};
		price = 				{_de="Preis", 					_en="Price",					_ru="Цена"};
		prices = 				{_de="Preise", 					_en="Prices",					_ru="Цены"};	
		hectar = 				{_de="Hectar", 					_en="Hectar",					_ru="Гектар"};
		fieldstotal = 			{_de="Felder gesamt", 			_en="Fieldstotal",				_ru="Всего полей"};
		foodtrough = 			{_de="Futtertrog",				_en="Foodtrough",				_ru="Кормушка"};
		empty = 				{_de="-Leer-", 					_en="-Empty-",					_ru="-Пусто-"};
		times = 				{_de="Zeit", 					_en="Time",						_ru="Время"};
		times1 = 				{_de="Zeiten", 					_en="Times",					_ru="Время"};
		hours = 				{_de="Stunden", 				_en="Hours",					_ru="Часов"};
		hour = 					{_de="Stunde", 					_en="Hour",						_ru="Час"};	
		at = 					{_de="in", 						_en="at",						_ru="в"};
		big = 					{_de="extra groß", 				_en="big",						_ru="очень много"};
		large = 				{_de="groß", 					_en="large",    				_ru="много"};
		middle = 				{_de="mittel", 					_en="middle",    				_ru="средне"};
		small = 				{_de="klein", 					_en="small",    				_ru="мало"};
		shop = 					{_de="Shop", 					_en="Shop",    				    _ru="Магазин"};
		tree = 					{_de="Baum", 					_en="Tree",    				    _ru="Дерево"};
		trees = 				{_de="Bäume", 					_en="Trees",    				_ru="Деревья"};
		bale = 					{_de="Ballen", 					_en="Bale",    				    _ru="Тюк"};
		farm = 					{_de="Bauernhof", 				_en="Farm",    				    _ru="Ферма"};
		owner = 				{_de="Eigene", 					_en="Owner",    				_ru="Владелец"};
		ownernofound = 			{_de="Keine gefunden", 			_en="Not Found",    			_ru="Не найдено"};
		farmsilos = 			{_de="Hofsilo", 				_en="Farmsilo",    			    _ru="Хранилище на ферме"};
		silo = 					{_de="Silo", 					_en="Silo",    				    _ru="Хранилище"};
		silos = 				{_de="Silos", 					_en="Silos",    				_ru="Хранилища"};
		train = 				{_de="Zug", 					_en="Train",    				_ru="Поезд"};
		trains = 				{_de="Züge", 					_en="Trains",    				_ru="Поезда"};
		level = 				{_de="Stufe", 					_en="Level",    				_ru="Стадия"};
		levels = 				{_de="Stufen", 					_en="Levels",    				_ru="Стадии"};
		fruit = 				{_de="Frucht", 					_en="Fruit",    				_ru="Культура"};
		fruittype = 			{_de="Fruchtart", 				_en="Fruittype",    			_ru="Тип культуры"};
		fruits = 				{_de="Früchte", 				_en="Fruits",    				_ru="Культуры"};
		stock = 				{_de="Lager", 					_en="Stock",    				_ru="Склад"};
		amount = 				{_de="Bestand", 				_en="Amount",    				_ru="Объём"};
		potatos = 				{_de="Kartoffeln", 				_en="Potatos",    				_ru="Картофель"};
		sugarbeets = 			{_de="Zuckerrüben",				_en="Sugarbeets",    			_ru="Сахарная сёкла"};
		grass = 				{_de="Gras", 					_en="Grass",    				_ru="Трава"};
		straw = 				{_de="Stroh", 					_en="Straw",    				_ru="Солома"};
		food = 					{_de="Futter", 					_en="Food",    				    _ru="Корм"};
		silage = 				{_de="Silage", 					_en="Silage",    				_ru="Силос"};
		manure = 				{_de="Mist", 					_en="Manure",    				_ru="Навоз"};
		liquidmanure = 			{_de="Gülle", 					_en="Liquidmanure",    		    _ru="Жид. навоз"};
		age = 					{_de="Alt", 					_en="Age",    				    _ru="Возраст"};
		ages = 					{_de="Alter", 					_en="Ages",    				    _ru="Возраст"};
		ageday =				{_de="Tag", 					_en="Day",    				    _ru="День"};
		agedays =				{_de="Tage", 					_en="Days",    				    _ru="Дней"};
		animal = 				{_de="Tier", 					_en="Animal",    				_ru="Животное"};
		animals = 				{_de="Tiere", 					_en="Animals",    				_ru="Животные"};
		egg = 					{_de="Eier", 					_en="Eggs",    				    _ru="Яйца"};
		eggsbarn = 				{_de="Eier im Stall", 			_en="Eggs in the barn",    		_ru="Яйца в курятнике",    		_nl="Eieren in de schuur"};
		pickup = 				{_de="Eier im Rucksack", 		_en="Eggs carrying",    		_ru="Яйца в транспорте",		_nl="Eggs carrying"};
		wool = 					{_de="Wolle", 					_en="Wool",    				    _ru="Шерсть"};
		cow = 					{_de="Kühe", 					_en="Cow",    				    _ru="Корова"};
		sheep = 				{_de="Schafe", 					_en="Sheep",    				_ru="Овца"};
		chicken = 				{_de="Hühner", 					_en="Chicken",    				_ru="Курица"};
		pig = 					{_de="Schweine", 				_en="Pig",    				    _ru="Свинья"};
		horse = 				{_de="Pferde", 					_en="Horse",    				_ru="Лошадь"};
		animalsstall = 			{_de="Tierställe", 				_en="Animalstall",    			_ru="Загоны для животных"};
		animalstall = 			{_de="Tierstall", 				_en="Animalstall",    			_ru="Загон для животных"};
		factory = 				{_de="Fabrik", 					_en="Factory",    				_ru="Производство"};
		factorys = 				{_de="Fabriken", 				_en="Factorys",    			    _ru="Производства"};
		harvest = 				{_de="Erntereif", 				_en="Harvest",    				_ru="Созрело"};
		growth = 				{_de="Wachstum", 				_en="Growth",    				_ru="Растёт"};
		--cut = 					{_de="Alte Saat"};
		plough = 				{_de="Gegrubert", 				_en="Plough",    				_ru="Вспахано"};
		plowing = 				{_de="Pflügen", 				_en="Plowing",    				_ru="Нужна вспашка"};
		weeds = 				{_de="Unkraut", 				_en="Weeds",    				_ru="Сорняки"};
		lime = 					{_de="Kalk", 					_en="Lime",    				    _ru="Lime"};
		fertilizer = 			{_de="Flüssigdünger", 			_en="Fertilizer",    			_ru="Fertilizer"};
		sprayed = 				{_de="Gedüngt", 				_en="Sprayed",    				_ru="Sprayed"};
		sprayer = 				{_de="Gespritzt", 				_en="Sprayer",    				_ru="Sprayer"};
		windrow = 				{_de="Gedroschen", 				_en="Windrows",    			    _ru="Windrows"};
		wasteland =	 			{_de="Brachland", 				_en="Wasteland",    			_ru="Пустошь"};
		oldseed = 				{_de="Alte Saat", 				_en="Oldseed",    				_ru="Oldseed"};
		seed = 					{_de="Saat", 					_en="Seed",    				    _ru="Seed"};
		seeds = 				{_de="Gesaet", 					_en="Seeds",    				_ru="Seeds"};
		station = 				{_de="Station", 				_en="Station",    				_ru="Станция"};
		sellingstations =  		{_de="Verkauf Stationen", 		_en="Selling Stations",    	    _ru="Пункт продажи"};
		buyingstations =  		{_de="Einkauf Stationen", 		_en="Buying Stations",    		_ru="Пункт покупки"};
		buyingwater =  			{_de="Wasserstelle", 			_en="Watering hole",    		_ru="Водокачка"};
		unknown = 				{_de="Unbekannt", 				_en="Unknown",    				_ru="Неизвестное"};
		costday = 				{_de="Kosten(Tag)", 			_en="Cost(Day)",    			_ru="Стоимость(В день)"};
		fillcontainer = 		{_de="Füllbehälter", 			_en="Fillcontainer",    		_ru="Контейнер"};
		factor = 				{_de="Faktor", 					_en="Factor",    				_ru="Фактор"};
		pallets = 				{_de="Pal.", 					_en="Pal.",    				    _ru="Подд."};
		cleanliness = 			{_de="Sauberkeit", 				_en="Cleanliness",    			_ru="Чистота"};
		total = 				{_de="Total", 					_en="Total",    				_ru="Всего"};
		incomeperhour =			{_de="Einnahmen(Stunde)", 		_en="Income(Hour)",    		    _ru="Доход (В час)"};
		greenhouses =			{_de="Gewächshäuser", 			_en="Greenhouses",    			_ru="Теплицы"};
		greenhouse =			{_de="Gewächshaus", 			_en="Greenhouse",    			_ru="Теплица"};
		windturbine =			{_de="Windturbine", 			_en="Windturbine",    			_ru="Ветряная турбина"};
		windturbinen =			{_de="Windturbinen", 			_en="Windturbinen",    		    _ru="Ветряные турбины"};
		solarcollector =		{_de="Solaranlage", 			_en="Solarcollector",    		_ru="Солнечная батарея"};
		solarcollectoren =		{_de="Solaranlagen", 			_en="Solarcollectoren",    	    _ru="Солнечные батареи"};
		heatingplant =			{_de="Heizkraftwerk", 			_en="Heatingplant",    		    _ru="Котельная"};
		heatingplants =			{_de="Heizkraftwerke", 			_en="Heatingplants",    		_ru="Котельные"};
		beehivehouse =			{_de="Bienenhaus", 				_en="Beehivehouse",    		    _ru="Улей"};
		beehivehouses =			{_de="Bienenhäuser", 			_en="Beehivehouses",    		_ru="Ульи"};
		bgas =					{_de="BGAs", 					_en="BGAs",    				    _ru="Биогазовые газогенераторы"};
		bga =					{_de="BGA", 					_en="BGA",    				    _ru="БГУ (BGA)"};
		catcher =				{_de="Shredder", 				_en="Catcher",    				_ru="Покос"};
		missionharvest =		{_de="Ernten", 					_en="Harvest",    				_ru="Собрать урожай"};
		missionsow =			{_de="Saen", 					_en="Sow",    				    _ru="Посеять"};
		missionfertilize =		{_de="Düngen", 					_en="Fertilize",    			_ru="Удобрить"};
		missionweed =			{_de="Mähen", 					_en="Weed",    				    _ru="Прополоть"};
		missiontransport =		{_de="Transportieren", 			_en="Transport",    			_ru="Перевезти"};
		missionmow_bale =		{_de="Ballenpressen", 			_en="Baling",    				_ru="Затюковать"};
		missionplow =			{_de="Pflügen", 				_en="Plow",    				    _ru="Вспахать"};
		missioncultivate =		{_de="Grubern", 				_en="Cultivate",    			_ru="Закультивировать"};
		missionspray =			{_de="Sprühen", 				_en="Spray",    				_ru="Опрыскать"};
		reproductionrate =		{_de="Reproduktionsrate", 		_en="Reproductionrate", 		_ru="Воспроизводство"};
		full = 					{_de="Voll",					_en="Full",    				    _ru="Заполнен"};
		bunker = 				{_de="Bunker",					_en="Bunker",    				_ru="Бункер"};
		bunkersilo = 			{_de="BunkerSilo",				_en="BunkerSilo",    			_ru="Хранилище"};
		bunkersilos = 			{_de="BunkerSilos",				_en="BunkerSilos",    			_ru="Хранилища"};
		bunkercompact = 		{_de="Verdichtung",				_en="Compression",    			_ru="Силосная яма"};
		bunkercompactfilllevel= {_de="Füllstand C",				_en="FillLevel C",    			_ru="Уровень заполнения"};
		bunkerfermenting = 		{_de="Gärung",					_en="Ferment",    				_ru="Ферментация"};
		bunkerfilllevel = 		{_de="Füllstand",				_en="FillLevel",    			_ru="Уровень заполнения"};
		greatdemand = 			{_de="Große Nachrage",			_en="GreatDemand",    			_ru="Большой спрос"};
		feedmixers = 			{_de="FutterMischer",			_en="FeedMixers",    			_ru="Смеситель корма"};
		storage = 				{_de="Lager",					_en="Storage",    				_ru="Склад"};
		storages = 				{_de="Lagers",					_en="Storages",    			    _ru="Склады"};
		objectstorages = 		{_de="ObjectLagers",			_en="ObjectStorages",    		_ru="Хранилища объектов"};
		filltypemovers = 		{_de="Fabrik(FM)",				_en="Factory(FM)",    			_ru="Потребн. произ-ва"};
		finish = 				{_de="Fertig",					_en="Finish",    				_ru="Готово"};
	};
	
	moLanguageIntern = {
		mohV3ninfo = {_de="Aktiviere oder Deaktivier den Mod\n!! Achtung Siehe auch HILFE !!",	_en="Set On or Off\n!! ATTENTION VIEW HELP !!",	_ru="Активировать или деактивировать мод\n!! ВНИМАНИЕ ПОСМОТРИТЕ СПРАВКУ !!"};
		mohV3nhelp1 = {_de="Ist der Mod Deaktiviert\ndann Aktiviere dieses Menue mit der\nStandart Taste (F12)\n'MoV3OnOffMouseCursor' --> LS19 Tastatur Belegung",	_en="Is MOH OFF then Activate this GuiMenue with Default Key(F12)\n'MoV3OnOffMouseCursor' ----> LS19 Keypad Settings Optionen",	_ru="Если мод деактивирован\nто активируйте это меню\nстандартной клавишей (F12)\n'MoV4OnOffMouseCursor' --> Назначение клавиш FS22"};
		keyselectinfo = {_de="Aktiviere oder Deaktivier die Tastatur Steuerung", _en="Set KeySelect On or Off", _ru="Включить или отключить управление с клавиатуры"};
		keyselecthelp1 = {_de="Optional kann man die PDAs mit den Tasten Steuern\nStandart ist das der Pfeiltasten Block\nLinks/Rechts/Hoch/Runter", _en="Optional set KeySelect for Control PDAs with keypad\nDefault Left/Right/Up/Down KeyPadBlock", _ru="При желании вы можете управлять КПК с помощью клавиш\nПо умолчанию используется блок клавиш со стрелками\nВлево/Вправо/Вверх/Вниз"};
		setfrozeninfo = {_de="Ist der MouseCoursor An dann wird die Spieler Bewegung Automatisch eingefroren", _en="Is MouseCursor ON then set Player Frozen", _ru="Если курсор мыши включён, то движение игрока автоматически замораживается"};
		setfrozenhelp1 = {_de="Andere Mods können das Verhindern/Blockieren oder Aufheben", _en="Another mod can prevent/obstruct that", _ru="Другие моды могут препятствовать/заблокировать или разблокировать его"};
		widthHeightZoomSlot = { _de="Sie können die Slot Größe unten rechts ändern (im Slot)\nMit der Maus können Sie bei Bedarf nach oben und unten scrollen(+IconButton)\nund ggf. mit dem Schieberegler(+Maus) nach links oder rechts", _en="You can change the slot size at the bottom right (at slot)\nWith the mouse you can scroll up and down if necessary(+IconButton)\nand with the slider(+Mouse) to the left or right if necessary", _ru="Вы можете изменить размер слота внизу справа (внутри слота)\nВы можете использовать мышь для прокрутки вверх и вниз (+кнопка значка)\nи, при необходимости, использовать ползунок (+мышь) влево или вправо"};
		pdaTypeLightFirstStart = { _de="!! Neuen PDA Type (light) gefunden !!\nSoll dieser Aktiviert werden ?\n(Global PDA für alle Profile)\n*Optional An/Aus diesen PDA Type via GUI Menü\n--> (MultiOverlayV4 / GlobalSettings)\n! Deine MOH PDA Huds überlappen event. den neue PDA Type !\n(setze diese auf neue Positionen)", _en="!! Found New PDA Type (light) !!\nNew PDA Type (light) Activate ?\n(Global PDA for all Profile)\n*Optional On/Off this PDA Type via GUI Menue\n--> (MultiOverlayV4 / GlobalSettings)\n! Your MOH PDA Huds possible overlap new PDA Type !\n(set this to new positions)", _ru="!! Найден новый тип КПК (лёгкий) !!\nНовый тип КПК (лёгкий) Активировать?\n(Глобальный КПК для всех профилей)\n*Опциональное вкл/выкл этого типа КПК в меню графического интерфейса\n--> (MultiOverlayV4 / Глобальные настройки)\n! Дисплеи вашего MOH КПК могут перекрывать новый тип КПК !\n(разместить в других позициях)"};
		pdaTypeLightGeneratePda = { _de="!! PDA nicht gefunden !!\nSoll dieser erstellt werden (Clone) ?\n(Global PDA für alle Profile)\n! Deine MOH PDA Huds überlappen event. das neue PDA !\n(setze diese auf neue Positionen)", _en="!! Not Found PDA !!\nPDA Generate (Clone) ?\n(Global PDA for all Profile)\n! Your MOH PDA Huds possible overlap new PDA !\n(set this to new positions)", _ru="!! Не найден КПК !!\nСоздать КПК (Клонировать) ?\n(Глобальный КПК для всех профилей)\n! Дисплеи вашего MOH КПК могут перекрывать новый тип КПК !\n(разместить в других позициях)"};
	};
end;

function moLanguageXml:randomTextTickerTxt(playerName) 
	local txt = {g_i18n:getText("achievement_descBreedChicken"),g_i18n:getText("achievement_descPlayTime"),playerName.. g_i18n:getText("ui_howDoYouLikeTheGame"),playerName.. g_i18n:getText("achievement_nameLoadedOldSavegame"),playerName.. g_i18n:getText("achievement_descPetDog"),g_i18n:getText("achievement_descLoadedOldSavegame".. playerName),
	g_i18n:getText("achievement_nameDeliveryOlives").. playerName,g_i18n:getText("achievement_descBreedCows").. " ".. g_i18n:getText("achievement_descBreedPigs"),playerName.. g_i18n:getText("achievement_descCollectiblesUS"),g_i18n:getText("achievement_descCollectiblesAlpine"),g_i18n:getText("achievementFileDescription_psn").. " ".. g_i18n:getText("achievement_descCollectiblesFR"), 
	g_i18n:getText("ui_ingameMenuHelpLine").. playerName.. " ".. g_i18n:getText("achievement_descMoney"),playerName.. g_i18n:getText("achievement_descNumDrivables"),playerName.. g_i18n:getText("achievement_descNumPlaceables"),g_i18n:getText("achievement_descSowFirst").. playerName.. " ".. g_i18n:getText("function_mower"),playerName.. g_i18n:getText("achievement_descVehicleRepaint"),
	g_i18n:getText("achievement_descVehicleRepairFirst").. playerName,g_i18n:getText("achievement_nameBreedChicken").. " ".. g_i18n:getText("achievement_descPlayTime"),playerName.. g_i18n:getText("achievement_nameBreedCows"),g_i18n:getText("achievement_nameBreedPigs").. " ".. g_i18n:getText("achievement_nameBreedSheep"),g_i18n:getText("achievement_nameCollectiblesAlpine").. playerName.. " ".. g_i18n:getText("achievement_nameCottonBales"),
	g_i18n:getText("achievement_nameCarDriving").. " ".. g_i18n:getText("achievement_nameCollectiblesUS").. playerName,g_i18n:getText("achievement_nameCutTreeFirst").. " ".. g_i18n:getText("achievement_nameCollectiblesFR"),g_i18n:getText("achievement_nameDeliverySorghum").. playerName.. " ".. g_i18n:getText("achievement_nameDeliveryGrapes"),
	g_i18n:getText("achievement_nameFertilize").. " ".. g_i18n:getText("achievement_descSow"), g_i18n:getText("achievement_descTruckDriving").. playerName,g_i18n:getText("achievement_nameGotAllAchievements").. " ".. g_i18n:getText("achievement_nameHarvested"),g_i18n:getText("achievement_nameHarvestedFirst").. " ".. g_i18n:getText("achievement_nameHorseJumps"),
	playerName.. g_i18n:getText("achievement_nameMission"),g_i18n:getText("achievement_nameMissionFirst").. " ".. g_i18n:getText("achievement_nameMoney").. playerName,g_i18n:getText("achievement_nameNumBeehives"),g_i18n:getText("achievement_descCultivate"),playerName.. g_i18n:getText("achievement_descCultivateFirst"),
	playerName.. g_i18n:getText("achievement_descCutTreeFirst").. " ".. g_i18n:getText("achievement_descCutTree"),g_i18n:getText("achievement_descHarvestedFirst"),g_i18n:getText("ui_collectibleMessageTitle").. " ".. g_i18n:getText("achievement_nameWrappedBales"),g_i18n:getText("achievement_nameCultivateFirst"),
	g_i18n:getText("achievement_nameNumVehiclesLarge"),g_i18n:getText("achievement_descDeliveryGrapes"),g_i18n:getText("achievement_nameNumProductionPoints").. playerName,g_i18n:getText("achievement_descMissionFirst"),g_i18n:getText("achievement_descFertilizeFirst"),g_i18n:getText("achievement_descHarvested"),
	playerName.. g_i18n:getText("achievement_nameSowFirst"),g_i18n:getText("achievement_nameNumPlaceables").. playerName,g_i18n:getText("achievement_nameTruckDriving").. playerName.. " ".. g_i18n:getText("achievement_nameNumVehiclesSmall"),g_i18n:getText("achievement_namePetDog").. " ".. playerName,g_i18n:getText("achievement_namePlayTime").. playerName.. " ".. g_i18n:getText("achievement_nameTractorDriving"),g_i18n:getText("achievement_nameSow"),
	g_i18n:getText("achievement_nameVehicleRepaint").. " ".. g_i18n:getText("achievement_nameVehicleRepairFirst"),g_i18n:getText("achievement_descGotAllAchievements"),g_i18n:getText("info_tipSideBack").. " ".. g_i18n:getText("achievement_descFertilize"),playerName.. g_i18n:getText("achievement_descDeliveryStones"),g_i18n:getText("achievement_descDeliverySorghum"),
	playerName.. g_i18n:getText("achievement_descDeliveryOlives"),g_i18n:getText("statistic_eggsCarrying").. " ".. g_i18n:getText("achievement_descCottonBales"),g_i18n:getText("achievement_nameHorseRiding").. " ".. g_i18n:getText("achievement_nameHorseJumpsFirst"),g_i18n:getText("ui_kickTitle").. " ".. g_i18n:getText("achievement_descNumBeehives"),
	 g_i18n:getText("achievement_nameHorseRidingFirst").. " ".. g_i18n:getText("achievement_descHorseRidingFirst")}; 
	local randomTxt = math.random(1, #txt);
	return txt[randomTxt];
end;
