moAmounts = {};
source(MultiOverlayV4.modDir.."scripte/module/amounts/moAmountsConfig.lua");
--source(MultiOverlayV4.modDir.."scripte/module/amounts/moAmountsOutput.lua");

function moAmounts:update(dt)
	if moModule:getActiveRunningModul( {modName="multiOverlayV4", modulName="amounts"} ) then
		if moAmountsConfig.values.updateTimer > 0 then
			if g_currentMission.hl.timers["updateAmounts"] ~= nil then return;end;
			g_currentMission.hl.addTimer( {delay=moAmountsConfig.values.updateTimer, name="updateAmounts", repeatable=1, ms=moAmountsConfig.values.msec, action=moAmounts.load} ); 
		else
			moAmounts:load();
		end;
	end;
end;

function moAmounts.loadOnStart(update) --onStartMission Callback, update = updateByPlayer !new object or delete object etc. delete your old cmds!	
	if moAmountsConfig.values == nil then moAmountsConfig:defaultValues();end;	
	moAmounts:loadAllAmounts();
	
end;

function moAmounts.load() --updateTimer Callback	
	moAmounts:loadAllAmounts();	
end;

function moAmounts:loadAllAmounts()	
	local playerFarmId = g_currentMission.player.farmId;	
	--local farmId = g_currentMission:getFarmId()
	moFillTypes.values.amount = {}; --new
	moFillTypes.values.storages = {}; --new	
	for _, storage in pairs(g_currentMission.storageSystem:getStorages()) do
		if storage:getOwnerFarmId() == playerFarmId then --and storage.foreignSilo ~= farmSilo then	--train other		
			local fillLevels = storage:getFillLevels();
			if fillLevels ~= nil then
				for fillType, fillLevel in pairs(fillLevels) do
					if storage:getIsFillTypeSupported(fillType) then
						moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);
						if storage.loadingStations ~= nil then
							for _, loadingStation in pairs (storage.loadingStations) do
								local objectId = loadingStation.rootNode or loadingStation.nodeId;
								if objectId ~= nil then
									local mapHotspot = nil;
									if loadingStation.owningPlaceable ~= nil then mapHotspot = loadingStation.owningPlaceable.spec_hotspots;end;
									if moFillTypes.values.storages[fillType] == nil then moFillTypes.values.storages[fillType] = {storage={}};end;
									if moFillTypes.values.storages[fillType].storage[objectId] == nil then 
										moFillTypes.values.storages[fillType].storage[objectId] = {objectId=objectId,mapHotspot=mapHotspot,fillLevel=0,storageName="",production=loadingStation.owningPlaceable ~= nil and loadingStation.owningPlaceable.spec_productionPoint ~= nil};
										moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(fillLevel, 0);
										moFillTypes.values.storages[fillType].storage[objectId].storageName = Utils.getNoNil(loadingStation:getName(), "Unknown");
										--if test and moFillTypes.values.storages[fillType].storage[objectId].storageName == "Multi Produktionsfabrik" then
										--	test = false;
										--	print(DebugUtil.printTableRecursively(storage.loadingStations, "storage ", 0, 2))
										--end;
									else
										moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(moFillTypes.values.storages[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
									end;
								end;								
							end;
						end;						
					end;					
				end;				
			end;			
		end;		
	end;	
	moItems.load();
	if (g_server ~= nil and g_client ~= nil and g_dedicatedServer == nil and not g_currentMission.missionDynamicInfo.isMultiplayer) then --or (g_server ~= nil and g_client ~= nil and g_dedicatedServer == nil and g_currentMission.missionDynamicInfo.isMultiplayer) then
		moAmounts:loadAllObjectStoragesSP();
	else
		moAmounts:loadAllObjectStoragesMP();
	end;
	moAnimals:loadNumOfAnimals();
	moProductionPoints:loadAmounts();	
end;

function moAmounts:loadAllObjectStoragesSP()
	--getLoadingStations()
	
	local playerFarmId = g_currentMission.player.farmId;
	if moModule.placeableObjectStorages ~= nil and #moModule.placeableObjectStorages > 0 then
		local deleteObject = {};
		for index=1, #moModule.placeableObjectStorages do			
			if moModule.placeableObjectStorages[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.placeableObjectStorages[index].object);
				if isObject then
					local objectStorage = moModule.placeableObjectStorages[index].object;
					if objectStorage ~= nil and objectStorage.ownerFarmId == playerFarmId and objectStorage.spec_objectStorage ~= nil then
						local objectId = objectStorage.rootNode or objectStorage.nodeId;
						if objectId ~= nil then							
							local mapHotspot = nil;
							if objectStorage.spec_hotspots ~= nil then mapHotspot = objectStorage.spec_hotspots;end;
							local capacity = objectStorage.spec_objectStorage.capacity;
							local numObjects = objectStorage.spec_objectStorage.numStoredObjects;
							for o=1, #objectStorage.spec_objectStorage.storedObjects do
								local storageObject = objectStorage.spec_objectStorage.storedObjects[o];
								if storageObject ~= nil then
									if storageObject.palletAttributes ~= nil then
										local fillType = storageObject.palletAttributes.fillType;
										local fillLevel = storageObject.palletAttributes.fillLevel;
										moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);										
										if moFillTypes.values.storages == nil then moFillTypes.values.storages = {};end;
										if moFillTypes.values.storages[fillType] == nil then moFillTypes.values.storages[fillType] = {storage={}};end;
										if moFillTypes.values.storages[fillType].storage[objectId] == nil then 
											moFillTypes.values.storages[fillType].storage[objectId] = {objectId=objectId,mapHotspot=mapHotspot,fillLevel=0,storageName="",production=false,pal=0};
											moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(fillLevel, 0);
											moFillTypes.values.storages[fillType].storage[objectId].storageName = Utils.getNoNil(objectStorage:getName(), "Unknown");
											moFillTypes.values.storages[fillType].storage[objectId].pal = 1;
										else
											moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(moFillTypes.values.storages[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
											moFillTypes.values.storages[fillType].storage[objectId].pal = moFillTypes.values.storages[fillType].storage[objectId].pal+1;
										end;
										
									end;
									if storageObject.baleAttributes ~= nil then										
										local fillType = storageObject.baleAttributes.fillType;
										local fillLevel = storageObject.baleAttributes.fillLevel;
										moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);
										if moFillTypes.values.storages == nil then moFillTypes.values.storages = {};end;
										if moFillTypes.values.storages[fillType] == nil then moFillTypes.values.storages[fillType] = {storage={}};end;
										if moFillTypes.values.storages[fillType].storage[objectId] == nil then 
											moFillTypes.values.storages[fillType].storage[objectId] = {objectId=objectId,mapHotspot=mapHotspot,fillLevel=0,storageName="",production=false,bales=0};
											moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(fillLevel, 0);
											moFillTypes.values.storages[fillType].storage[objectId].storageName = Utils.getNoNil(objectStorage:getName(), "Unknown");
											moFillTypes.values.storages[fillType].storage[objectId].bales = 1;
										else
											moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(moFillTypes.values.storages[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
											moFillTypes.values.storages[fillType].storage[objectId].bales = moFillTypes.values.storages[fillType].storage[objectId].bales+1;
										end;														
									end;									
								end;								
							end;											
						end;											
					end;
				else					
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.placeableObjectStorages, index);
			end;						
		end;
	end;
end;

function moAmounts:loadAllObjectStoragesMP()
	--getLoadingStations()
	
	local playerFarmId = g_currentMission.player.farmId;
	if moModule.placeableObjectStorages ~= nil and #moModule.placeableObjectStorages > 0 then
		local deleteObject = {};
		for index=1, #moModule.placeableObjectStorages do			
			if moModule.placeableObjectStorages[index] ~= nil then
				local isObject = moModuleObjects:isObject(moModule.placeableObjectStorages[index].object);
				if isObject then
					local objectStorage = moModule.placeableObjectStorages[index].object;
					if objectStorage ~= nil and objectStorage.ownerFarmId == playerFarmId and objectStorage.spec_objectStorage ~= nil then
						local objectId = objectStorage.rootNode or objectStorage.nodeId;
						if objectId ~= nil and objectStorage.spec_objectStorage.objectInfos ~= nil and #objectStorage.spec_objectStorage.objectInfos > 0 then							
							local mapHotspot = nil;
							if objectStorage.spec_hotspots ~= nil then mapHotspot = objectStorage.spec_hotspots;end;
							local capacity = objectStorage.spec_objectStorage.capacity;
							local numObjects = objectStorage.spec_objectStorage.numStoredObjects;
							for o=1, #objectStorage.spec_objectStorage.objectInfos do
								if objectStorage.spec_objectStorage.objectInfos[o].objects ~= nil and #objectStorage.spec_objectStorage.objectInfos[o].objects > 0 then
									for oS=1, #objectStorage.spec_objectStorage.objectInfos[o].objects do
										local storageObject = objectStorage.spec_objectStorage.objectInfos[o].objects[oS];								
										if storageObject ~= nil then
											if storageObject.palletAttributes ~= nil then
												local fillType = storageObject.palletAttributes.fillType;
												local fillLevel = storageObject.palletAttributes.fillLevel;
												moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);										
												if moFillTypes.values.storages == nil then moFillTypes.values.storages = {};end;
												if moFillTypes.values.storages[fillType] == nil then moFillTypes.values.storages[fillType] = {storage={}};end;
												if moFillTypes.values.storages[fillType].storage[objectId] == nil then 
													moFillTypes.values.storages[fillType].storage[objectId] = {objectId=objectId,mapHotspot=mapHotspot,fillLevel=0,storageName="",production=false,pal=0};
													moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(fillLevel, 0);
													moFillTypes.values.storages[fillType].storage[objectId].storageName = Utils.getNoNil(objectStorage:getName(), "Unknown");
													moFillTypes.values.storages[fillType].storage[objectId].pal = 1;
												else
													moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(moFillTypes.values.storages[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
													moFillTypes.values.storages[fillType].storage[objectId].pal = moFillTypes.values.storages[fillType].storage[objectId].pal+1;
												end;
												
											end;
											if storageObject.baleAttributes ~= nil then										
												local fillType = storageObject.baleAttributes.fillType;
												local fillLevel = storageObject.baleAttributes.fillLevel;
												moFillTypes.values.amount[fillType] = Utils.getNoNil(moFillTypes.values.amount[fillType], 0) + Utils.getNoNil(fillLevel, 0);
												if moFillTypes.values.storages == nil then moFillTypes.values.storages = {};end;
												if moFillTypes.values.storages[fillType] == nil then moFillTypes.values.storages[fillType] = {storage={}};end;
												if moFillTypes.values.storages[fillType].storage[objectId] == nil then 
													moFillTypes.values.storages[fillType].storage[objectId] = {objectId=objectId,mapHotspot=mapHotspot,fillLevel=0,storageName="",production=false,bales=0};
													moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(fillLevel, 0);
													moFillTypes.values.storages[fillType].storage[objectId].storageName = Utils.getNoNil(objectStorage:getName(), "Unknown");
													moFillTypes.values.storages[fillType].storage[objectId].bales = 1;
												else
													moFillTypes.values.storages[fillType].storage[objectId].fillLevel = Utils.getNoNil(moFillTypes.values.storages[fillType].storage[objectId].fillLevel, 0) + Utils.getNoNil(fillLevel, 0);
													moFillTypes.values.storages[fillType].storage[objectId].bales = moFillTypes.values.storages[fillType].storage[objectId].bales+1;
												end;														
											end;									
										end;
									end;
								end;
							end;											
						end;											
					end;
				else					
					table.insert(deleteObject, index);
				end;
			end;
		end;
		if #deleteObject > 0 then
			for _, index in pairs (deleteObject) do				
				table.remove(moModule.placeableObjectStorages, index);
			end;						
		end;
	end;
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="amounts" } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="onStartMission", callback=moAmounts.loadOnStart } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="update", callback=moAmounts.update } );