moMissionsConfig = {};

function moMissionsConfig:defaultValues()
	moMissions.values = {missions={}, fieldToMission={}, viewOnlyActive=false, viewSortByLine=true, viewIcons=1, sortBy=1, updateTimer=2, msec=false, pdaTypeLight={prozent=0,notice=false,updateTimer=15,textTickerTimer=180,tickerTxtRepeatable=1,tickerTxt=""}};
	--sortBy 1=price, 2=jobType, 3=hectar, 4=field
end;

function moMissionsConfig.loadXml(Xml, xmlNameTag, directory, typ) --loadConfig Callback	
	if typ ~= "profilSettings" then return;end;
	if moMissions.values == nil then moMissionsConfig:defaultValues();end;	
	local groupNameTag = (xmlNameTag.. ".module.missions(%d)"):format(0);
	if getXMLBool(Xml, groupNameTag.. "#viewOnlyActive") ~= nil then
		moMissions.values.viewOnlyActive = getXMLBool(Xml, groupNameTag.. "#viewOnlyActive");
	else
		return; --first config not found
	end;
	if getXMLBool(Xml, groupNameTag.. "#viewSortByLine") ~= nil then
		moMissions.values.viewSortByLine = getXMLBool(Xml, groupNameTag.. "#viewSortByLine");
	end;
	if getXMLInt(Xml, groupNameTag.. "#viewIcons") ~= nil then
		moMissions.values.viewIcons = getXMLInt(Xml, groupNameTag.. "#viewIcons");	
	end;
	if getXMLInt(Xml, groupNameTag.. "#sortBy") ~= nil then
		moMissions.values.sortBy = getXMLInt(Xml, groupNameTag.. "#sortBy");	
	end;
end;

function moMissionsConfig.saveXml(Xml, xmlNameTag, directory, typ) --saveConfig Callback
	if typ ~= "profilSettings" then return;end;	
	if moMissions.values == nil then moMissionsConfig:defaultValues();end;
	----------------------------------------------------------------------------------------------
	local groupNameTag = (xmlNameTag.. ".module.missions(%d)"):format(0);
	setXMLInt(Xml, groupNameTag.. "#viewIcons", moMissions.values.viewIcons);
	setXMLInt(Xml, groupNameTag.. "#sortBy", moMissions.values.sortBy);
	setXMLBool(Xml, groupNameTag.. "#viewOnlyActive", moMissions.values.viewOnlyActive);
	setXMLBool(Xml, groupNameTag.. "#viewSortByLine", moMissions.values.viewSortByLine);
	----------------------------------------------------------------------------------------------	
end;

function moMissionsConfig:generateCmd()
	function generateCmd(ownTable)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_mapMissions_";
				groupName = "OutputByMoh";			
				displayName = "Map Missions";
				infoTxt = "View Missions";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = ownTable;
				object = {};
				actionCallback = moMissionsOutput.giveOutputTable;			
			}
		)
		moSetGetCmd:generateCmd( {	
				modName = "MultiOverlayV4";
				cmdName = "output_mapMissionsOnlyActive_";
				groupName = "OutputByMoh";			
				displayName = "Map Missions (Only Active)";
				infoTxt = "View Only Active Missions";
				typ = {"output_"};
				mouseClickAccepts = {true,true,true};
				ownTable = {typ="onlyActiveCmd"};
				object = {};
				actionCallback = moMissionsOutput.giveOutputTable;			
			}
		)
	end;	
	generateCmd({});	
end;

moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="loadConfig", callback=moMissionsConfig.loadXml } );
moModule:addCallbackModul( {modName="multiOverlayV4", modulCallbackName="saveConfig", callback=moMissionsConfig.saveXml } );
