moMissionsOutput = {};
moMissionsOutputActive = {};

function moMissionsOutput:load(slotTable, onlyActiveCmd)
	local lineTable = {line={}};
	local isLineTable = nil;	
	local foundActiveMission = false;
	if moMissions.values.missions ~= nil then		
		if #moMissions.values.missions > 0 then
			local lastInsertTable = 1;
			for m=1, #moMissions.values.missions do
				local mission = moMissions.values.missions[m];			
				local color = "txt";
				local moreTxt = "";
				if mission.active then color = "txtExtra";end;
				if mission.finished then 
					color = "settingOn";
					if tonumber(mission.prozent) < 98 then color = "settingOff";end;
				end;				
				if mission.active or mission.finished then
					table.insert(lineTable.line, lastInsertTable, {});				
					isLineTable = lineTable.line[lastInsertTable];
					lastInsertTable = lastInsertTable+1;
					foundActiveMission = true;
				else
					lineTable.line[#lineTable.line+1] = {};
					isLineTable = lineTable.line[#lineTable.line];				
				end;
				isLineTable.txt = {};
				isLineTable.txt[1] = {};
				isLineTable.txt[1].bold = true;
				isLineTable.txt[1].slotColor = color;
				local money = g_i18n:formatMoney(mission.mission:getReward(), 0, true, true)
				isLineTable.txt[1].txt = tostring(money);
				isLineTable.txt[1].callback = moMissionsOutput.clickMissionsMoney;
				isLineTable.txt[1].ownTable = {mission.missionId};
				isLineTable.txt[1].width = 20;
				
				isLineTable.txt[2] = {};
				isLineTable.txt[2].bold = true;
				isLineTable.txt[2].slotColor = color;			
				local name = mission.jobType;
				local fillFruitName = "Unknown or not defined";
				local pickupMission = mission.numObjects ~= nil and mission.numObjects > 0;
				
				local missionIcon = nil;
				local missionIconO = nil;
				local fruitFillIcon = nil;
				local fruitFillIconO = nil;
				local viewIconAndTxt = "";
				function setMissionIcon()
					if mission.fertilizerMission ~= nil and mission.fertilizerMission and moFillTypes.values.mission["FERTILIZER"] ~= nil then
						fruitFillIcon = moFillTypes.values.mission["FERTILIZER"];
						missionIcon = "tractor";
					elseif mission.sprayMission ~= nil and mission.sprayMission and moFillTypes.values.mission["SPRAY"] ~= nil then
						fruitFillIcon = moFillTypes.values.mission["SPRAY"];
						missionIcon = "tractor";
					elseif mission.limeMission ~= nil and mission.limeMission and moFillTypes.values.mission["LIME"] ~= nil then
						fruitFillIcon = moFillTypes.values.mission["LIME"];
						missionIcon = "tractor";						
					elseif mission.weedMission ~= nil and mission.weedMission and moFillTypes.values.mission["WEED"] ~= nil then
						fruitFillIcon = moFillTypes.values.mission["WEED"];
						missionIcon = "tractor";
					elseif mission.sowMission ~= nil and mission.sowMission and moFillTypes.values.mission["SEEDS"] ~= nil then						
						fruitFillIconO = moFillTypes.values.mission["SEEDS"];
						missionIcon = "tractor";
					elseif mission.plowMission ~= nil and mission.plowMission then
						missionIcon = "tractor";
						missionIconO = "plow";				
					elseif mission.rollerMission ~= nil and mission.rollerMission then
						missionIcon = "tractor";
						missionIconO = "roller";
					elseif mission.cultivateMission ~= nil and mission.cultivateMission then
						missionIcon = "tractor";
						missionIconO = "cultivate";
					elseif mission.lieferMission ~= nil and mission.lieferMission then
						missionIcon = "tractor";
						missionIconO = "trailer";											
					elseif mission.harvestMission ~= nil and mission.harvestMission then
						missionIcon = "harvester";
					elseif mission.chaffMission ~= nil and mission.chaffMission then
						missionIcon = "chaffHarvester";
					elseif mission.baleMission ~= nil and mission.baleMission then
						missionIcon = "tractor";						
						if fruitFillIcon ~= nil then
							if fruitFillIcon == FillType.DRYGRASS_WINDROW then
								fruitFillIconO = moFillTypes.values.mission["baleDryGrass"];
							else
								fruitFillIconO = moFillTypes.values.mission["baleSilage"];
							end;
						end;
					elseif pickupMission then
						missionIcon = "stapler";
						missionIconO = "palette";						
						fruitFillIcon = nil;
					end;				
				end;				
				function setFruitIcon()					
					if missionIcon ~= nil then
						if isLineTable.txt[2].icon == nil then isLineTable.txt[2].icon = {before={},after={}};end;
						isLineTable.txt[2].icon.before[#isLineTable.txt[2].icon.before+1] = {name=missionIcon, slotColor=color, modName="MultiOverlayV4", groupName="mission"};
						if missionIconO ~= nil then
							isLineTable.txt[2].icon.before[#isLineTable.txt[2].icon.before+1] = {name=missionIconO, slotColor=color, modName="MultiOverlayV4", groupName="mission"};
						end;
					end;
					if fruitFillIcon ~= nil then 
						if moSetGetOverlays.icons["MultiOverlayV4"] ~= nil and moSetGetOverlays.icons["MultiOverlayV4"]["fruitFillType"] ~= nil and moSetGetOverlays.icons["MultiOverlayV4"]["fruitFillType"][fruitFillIcon] ~= nil then						
							if isLineTable.txt[2].icon == nil then isLineTable.txt[2].icon = {before={},after={}};end;
							if fruitFillIconO ~= nil then
								isLineTable.txt[2].icon.before[#isLineTable.txt[2].icon.before+1] = {name=fruitFillIconO, modName="MultiOverlayV4", groupName="fruitFillType", callback={[1]=moMissionsOutput.clickMissionsProzent}, ownTable={tostring(moFillTypes.values.fillTypes[fruitFillIcon].name)}};
							end;
							isLineTable.txt[2].icon.before[#isLineTable.txt[2].icon.before+1] = {name=fruitFillIcon, modName="MultiOverlayV4", groupName="fruitFillType", callback={[1]=moMissionsOutput.clickMissionsProzent}, ownTable={tostring(moFillTypes.values.fillTypes[fruitFillIcon].name)}};
						end;
					end;					
				end;
				if mission.isField then					
					if mission.fillType ~= nil then
						if moFillTypes.values.fillTypes[mission.fillType] ~= nil then
							fillFruitName = moFillTypes.values.fillTypes[mission.fillType].name;
							moreTxt = "#".. string.sub(fillFruitName, 1,3):upper();
							if mission.fillType == FillType.SUGARCANE or mission.fillType == FillType.CARROT then
								moreTxt = moreTxt.. "*"
							end;
							fruitFillIcon = mission.fillType;
						end;
					elseif mission.fruitType ~= nil then
						local fruitTypeIndex = g_fruitTypeManager:getFillTypeIndexByFruitTypeIndex(mission.fruitType);
						if moFillTypes.values.fillTypes[fruitTypeIndex] ~= nil then
							fillFruitName = moFillTypes.values.fillTypes[fruitTypeIndex].name;
							moreTxt = "#".. string.sub(fillFruitName, 1,3):upper();
							if mission.fruitType == FruitType.SUGARCANE or mission.fruitType == FruitType.CARROT then
								moreTxt = moreTxt.. "*"
							end;
							fruitFillIcon = fruitTypeIndex;							
						end;
					end;
					moreTxt = moreTxt.. "(F-".. tostring(mission.fieldId).. ") ".. tostring(string.format("%1.2f", "".. tostring(mission.fieldHectar))).. " ".. tostring(g_i18n:getText("unit_haShort"));
					viewIconAndTxt = "(F-".. tostring(mission.fieldId).. ") ".. tostring(string.format("%1.2f", "".. tostring(mission.fieldHectar))).. " ".. tostring(g_i18n:getText("unit_haShort"));
				elseif pickupMission then
					moreTxt = "(".. tostring(mission.numObjects).. ")";					
				end;				
				isLineTable.txt[2].txt = tostring(name).. tostring(moreTxt);
				if mission.lieferMission ~= nil and mission.lieferMission and mission.contractLiters ~= nil then
					local lieferTxt = "";
					if mission.fillType ~= nil and moFillTypes.values.fillTypes[mission.fillType] ~= nil then
						fillFruitName = moFillTypes.values.fillTypes[mission.fillType].name;
						lieferTxt = "#".. string.sub(fillFruitName, 1,3):upper();
						if mission.fruitType == FruitType.SUGARCANE or mission.fruitType == FruitType.CARROT then
							lieferTxt = lieferTxt.. "*"
						end;
					end;
					local isLiters = mission.contractLiters-Utils.getNoNil(mission.deliveredLiters, 0);
					if moMissions.values.viewIcons <= 2 then 
						if g_currentMission.hl.runsTimer("3sec", true) then
							isLineTable.txt[2].txt = lieferTxt.. "(".. tostring(string.format("%s %s", g_i18n:formatNumber(g_i18n:getVolume(isLiters), 0), g_i18n:getVolumeUnit(true))).. ")";
						end;
					else
						moreTxt = lieferTxt.. "(".. tostring(string.format("%s %s", g_i18n:formatNumber(g_i18n:getVolume(isLiters), 0), g_i18n:getVolumeUnit(true))).. ")";
						viewIconAndTxt = "(".. tostring(string.format("%s %s", g_i18n:formatNumber(g_i18n:getVolume(isLiters), 0), g_i18n:getVolumeUnit(true))).. ")";
					end;
				end;
				if moMissions.values.viewIcons > 1 then setMissionIcon();end;
				if moMissions.values.viewIcons == 3 then 
					isLineTable.txt[2].txt = tostring(moreTxt);
				elseif moMissions.values.viewIcons == 4 then 
					isLineTable.txt[2].txt = viewIconAndTxt;
				end;
				if mission.isField then					
					isLineTable.txt[2].callback = moMissionsOutput.clickMissionsName;					
					if fruitFillIcon ~= nil or missionIcon ~= nil then
						if moMissions.values.viewIcons > 1 then setFruitIcon();end;					
					end;
					if mission.sellPointId ~= nil and mission.sellPointId > 0 then
						isLineTable.txt[2].ownTable = {mission.fieldId, mission.sellPointId};
					else
						isLineTable.txt[2].ownTable = {mission.fieldId};
					end;
				elseif pickupMission then
					isLineTable.txt[2].callback = moMissionsOutput.clickMissionsNameTransport;
					isLineTable.txt[2].ownTable = {mission};				
					if moMissions.values.viewIcons > 1 then setFruitIcon();end;
					if moMissions.values.viewIcons >= 3 then 
						isLineTable.txt[2].txt = tostring(moreTxt);					
					end;					
				elseif mission.fillType ~= nil and mission.fillType > 0 and moFillTypes.values.fillTypes[mission.fillType] ~= nil then
					fruitFillIcon = mission.fillType;					
					if moMissions.values.viewIcons > 1 then setFruitIcon();end;
				end;
				isLineTable.txt[2].alignment = 2;
				isLineTable.txt[2].width = 65;
				
				moreTxt = "";
				isLineTable.txt[3] = {};
				isLineTable.txt[3].bold = true;
				isLineTable.txt[3].slotColor = color;
				if mission.vehicle then moreTxt = "L#";end;
				isLineTable.txt[3].txt = tostring(moreTxt).. tostring(mission.prozent).. "%";			
				if mission.isField then				
					isLineTable.txt[3].callback = moMissionsOutput.clickMissionsProzent;
					isLineTable.txt[3].ownTable = {fillFruitName};
				end;
				isLineTable.txt[3].alignment = 3;
				isLineTable.txt[3].width = 15;
				
				if (moMissions.values.viewOnlyActive or onlyActiveCmd) and not mission.active and not mission.finished then lineTable.line[#lineTable.line] = nil;end;
			end;	
		end;		
		
		table.insert(lineTable.line, 1, {});
		isLineTable = lineTable.line[1];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};	
		isLineTable.txt[1].slotColor = "txtOutputTitle";
		isLineTable.txt[1].bold = true;
		isLineTable.txt[1].txt = "Map ".. tostring(g_i18n:getText("ui_mapHotspotFilter_contracts")).. "(".. tostring(#moMissions.values.missions).. ")"; 
		isLineTable.txt[1].callback = moMissionsOutput.clickMissionsTotal;
		isLineTable.txt[1].alignment = 2;
		if slotTable ~= nil and slotTable.help.outputOn then
			isLineTable.txt[1].icon = {before={},after={}};			
			isLineTable.txt[1].icon.before[1] = {name="buttonHelp", color="yellow", settingButton=true, callback={[1]=moMissionsOutput.clickMissionsHelpTxt}};
		end;
		if isLineTable.txt[1].icon == nil then isLineTable.txt[1].icon = {before={},after={}};end;
		local iconColor = "gray";
		if moMissions.values.viewSortByLine then iconColor = "green";end;
		isLineTable.txt[1].icon.before[#isLineTable.txt[1].icon.before+1] = {name="outputSetting", color=iconColor, modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moMissionsOutput.clickMissionsViewSortByLine}};
		if #moMissions.values.missions <= 0 then
			table.insert(lineTable.line, 2, {});
			isLineTable = lineTable.line[2];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;
			local moreTxt = "";
			if onlyActiveCmd or moMissions.values.viewOnlyActive then moreTxt = "(Active)";end;
			isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_noMissions")).. moreTxt;
		elseif not foundActiveMission and onlyActiveCmd then
			table.insert(lineTable.line, 2, {});
			isLineTable = lineTable.line[2];
			isLineTable.txt = {};
			isLineTable.txt[1] = {};	
			isLineTable.txt[1].slotColor = "txt";
			isLineTable.txt[1].bold = true;			
			isLineTable.txt[1].txt = tostring(g_i18n:getText("ui_noPendingMissions"));
		else 
			if moMissions.values.viewSortByLine then
				table.insert(lineTable.line, 2, {});
				isLineTable = lineTable.line[2];
				isLineTable.txt = {};
				isLineTable.txt[1] = {};	
				isLineTable.txt[1].slotColor = "txtOutputTitle";
				isLineTable.txt[1].bold = true;		
				if moMissions.values.sortBy == 1 then
					isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Price*";
				elseif moMissions.values.sortBy == 2 then
					isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Type*";
				elseif moMissions.values.sortBy == 3 then
					isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Hectar*";
				elseif moMissions.values.sortBy == 4 then
					isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Field*";	
				else
					isLineTable.txt[1].txt = tostring(g_i18n:getText("button_sortTable", "Sort")).. " by *Fruit*";
				end;
				isLineTable.txt[1].callback = moMissionsOutput.clickMissionsSortBy;
				isLineTable.txt[1].icon = {before={},after={}};
				local otherColor = "gray"
				if moMissions.values.viewIcons > 1 then
					if moMissions.values.viewIcons == 4 then
						otherColor = "green";
					else
						otherColor = "yellow";
					end;
				end;
				isLineTable.txt[1].icon.before[1] = {name="tractor", color=otherColor, modName="MultiOverlayV4", groupName="mission", callback={[1]=moMissionsOutput.clickViewMissionsVehicle}};
				
				isLineTable.txt[1].icon.before[2] = {name="buttonFlip", color="green", modName="MultiOverlayV4", groupName="slotoutput", callback={[1]=moMissionsOutput.clickMissionsSortBy}};
			end;
		end;
		---objectLineDistance---
		lineTable.line[#lineTable.line+1] = {};
		isLineTable = lineTable.line[#lineTable.line];
		isLineTable.txt = {};
		isLineTable.txt[1] = {};		
		isLineTable.txt[1].txt = " ";
		---objectLineDistance---
	end;
	if onlyActiveCmd then
		moMissionsOutputActive.output = lineTable;
	else
		moMissionsOutput.output = lineTable;
	end;
end;

function moMissionsOutput.giveOutputTable(args)
	if args == nil or type(args) ~= "table" then return false;end;
	moModule:setActiveRunningModul( {modName="multiOverlayV4", modulName="missions" } );
	local onlyActiveCmd = args.cmdTable ~= nil and args.cmdTable.typ ~= nil and args.cmdTable.ownTable.typ == "onlyActiveCmd"; 
	moMissionsOutput:load(args.slotTable, onlyActiveCmd);
	if onlyActiveCmd then
		return moMissionsOutputActive.output;
	else
		return moMissionsOutput.output;
	end;
end;

function moMissionsOutput.clickMissionsViewSortByLine(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then		
		moMissions.values.viewSortByLine = not moMissions.values.viewSortByLine;
		MultiOverlayV4:setUnSave();
	end;
end;

function moMissionsOutput.clickViewMissionsVehicle(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if moMissions.values.viewIcons >= 4 then
			moMissions.values.viewIcons = 1;
		else
			moMissions.values.viewIcons = moMissions.values.viewIcons+1;
		end;
		MultiOverlayV4:setUnSave();
	end;
end;

function moMissionsOutput.clickMissionsSortBy(args)
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if moMissions.values.sortBy+1 > 5 then moMissions.values.sortBy = 1;else moMissions.values.sortBy = moMissions.values.sortBy+1;end;
		moMissions.load(args.slotTable); --refresh
	elseif args.mouseClick == "MOUSE_BUTTON_RIGHT" and args.isDown then	
		if moMissions.values.sortBy-1 < 1 then moMissions.values.sortBy = 5;else moMissions.values.sortBy = moMissions.values.sortBy-1;end;
		moMissions.load(args.slotTable); --refresh
	elseif args.mouseClick == "MOUSE_BUTTON_MIDDLE" and args.isDown then	
		moMissions.values.viewOnlyActive = not moMissions.values.viewOnlyActive;		
	end;
	MultiOverlayV4:setUnSave();
end;

function moMissionsOutput.clickMissionsHelpTxt(args)
	if args == nil or type(args) ~= "table" then return;end;	
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moSetGetOverlays.infoHelpBox.help.lsTimer = -1;
		moSetGetOverlays.infoHelpBox.help.titel = "Map Missions Help";
		moSetGetOverlays.infoHelpBox.help.txt = "Click Left Mouse Optional Map Missions/Sort By/Mission/Price for more Info or MapHotSpot or ...";
	end;
end;

function moMissionsOutput.clickMissionsTotal(args)	
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		moModule:showInGameMenuFrame("pageContracts", 0, true, false, 0);		
	end;
end;

function moMissionsOutput.clickMissionsProzent(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil then
			g_currentMission.hl.addTextDisplay( {txt="Mission Fill/FruitType: ".. tostring(args.ownTable[1]), txtBold=true, duration=3} );			
		end;
	end;
end;

function moMissionsOutput.clickMissionsName(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil and args.ownTable[1] > 0 then
			local field = g_fieldManager.fields[args.ownTable[1]];
			if field ~= nil then				
				local x, z = field:getCenterOfFieldWorldPosition();
				local x1, y1, z1 = 0,0,0;
				if args.ownTable[2] ~= nil and args.ownTable[2] > 0 then
					x1, y1, z1 = getWorldTranslation(args.ownTable[2]);
				end;
				if x ~= nil and x ~= 0 and x1 ~= nil and x1 ~= 0 then
					moSetGetOverlays:mapHotSpot({"Field", "Target"}, {x, x1}, {z, z1}, 2);					
				elseif x ~= nil and x ~= 0 then  
					moSetGetOverlays:mapHotSpot({"Field"}, {x}, {z}, 1);
				elseif x1 ~= nil and x1 ~= 0 then  
					moSetGetOverlays:mapHotSpot({"Target"}, {x1}, {z1}, 1);
				end;				
			end;			
		end;
	end;
end;

function moMissionsOutput.clickMissionsNameTransport(args)
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then	
		if args.ownTable[1] ~= nil then
			local mission = args.ownTable[1];			
			if mission.dropoffTrigger ~= nil and mission.pickupTrigger ~= nil then
				local trigger1 = g_missionManager.transportTriggers[mission.pickupTrigger];
				local trigger2 = g_missionManager.transportTriggers[mission.dropoffTrigger];
				local x, y, z = 0,0,0;
				local x1, y1, z1 = 0,0,0;
				if trigger1 ~= nil and trigger1.triggerId ~= nil then
					x, y, z = getWorldTranslation(trigger1.triggerId);				
				end;
				if trigger2 ~= nil and trigger2.triggerId ~= nil then
					x1, y1, z1 = getWorldTranslation(trigger2.triggerId);				
				end;
				if x ~= nil and x ~= 0 and x1 ~= nil and x1 ~= 0 then
					moSetGetOverlays:mapHotSpot({"Pickup", "Target"}, {x, x1}, {z, z1}, 2);
				elseif x ~= nil and x ~= 0 then  
					moSetGetOverlays:mapHotSpot({"Pickup"}, {x}, {z}, 1);
				elseif x1 ~= nil and x1 ~= 0 then  
					moSetGetOverlays:mapHotSpot({"Target"}, {x1}, {z1}, 1);
				end;
			end;
		end;
	end;
end;		

function moMissionsOutput.clickMissionsMoney(args)	
	if g_currentMission.player.farmId == 0 then return;end;
	if args == nil or type(args) ~= "table" or args.ownTable == nil then return;end;
	if args.mouseClick == "MOUSE_BUTTON_LEFT" and args.isDown then
		if args.ownTable[1] ~= nil then
			moModule:showInGameMenuFrame("pageContracts", args.ownTable[1], false, false, 0, false);			
		end;
	end;	
end;

moModule:addActiveRunningModul( {modName="multiOverlayV4", modulName="missions" } );